package com.yyrh.sdk;

import android.app.Activity;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.BitmapFactory;
import android.os.Build;
import android.os.Handler;
import android.util.Log;

import com.yyrh.constant.URLConstants;
import com.yyrh.factory.SdkManager;
import com.yyrh.imei.ImeiUtil;
import com.yyrh.pay.WvPayYyrhDialog;
import com.yyrh.sdk.callback.RealNameMsgCallback;
import com.yyrh.sdk.callback.ShowPolicyCallback;
import com.yyrh.sdk.callback.UserPolicyCallback;
import com.yyrh.ui.AutoLoginDialog;
import com.yyrh.ui.PrivacyPolicyDialog;
import com.yyrh.ui.SingleButtonDialog;
import com.yyrh.ui.activity.UseLoginActivity;
import com.yyrh.ui.floatmenu.FloatItem;
import com.yyrh.ui.floatmenu.FloatLogoMenu;
import com.yyrh.ui.floatmenu.FloatMenuView;
import com.yyrh.ui.floatmenu.WvPageListDialog;
import com.yyrh.ui.fragment.FragmentUtils;
import com.yyrh.ui.userlist.DatabaseHelper;
import com.yyrh.utils.InspectSimulator;
import com.yyrh.utils.ResourceUtil;
import com.yyrh.utils.Utils;
import com.yyrh.constant.SDKSettings;
import com.yyrh.networking.NetRequestApi;

import com.yyrh.sdk.callback.InitCallback;
import com.yyrh.ui.CustomExitGameDialog;
import com.yyrh.utils.YYLog;
import com.yythird.sdk.ChannelSDK;

import java.util.ArrayList;
import java.util.HashMap;



import static com.yyrh.constant.Constants.LOGOUT;


import static com.yyrh.constant.SDKSettings.isOpenFloatView;
import static com.yyrh.constant.SDKSettings.isOpenRealName;

import static com.yyrh.constant.SDKSettings.isVefityRealName;

public class YyrhSdkManager {
    private static YyrhSdkManager manager = null;


    FloatLogoMenu mFloatMenu;
    String HOME = "用户中心";
    String FEEDBACK = "切换账号";


    String CLOSE = "隐藏";
    String[] MENU_ITEMS = {HOME,FEEDBACK,CLOSE};
    private  Context context;

    ArrayList<FloatItem> itemList = new ArrayList<>();


    private YyrhSdkManager(Context context) {
       super();
        this.context = context;
    }

    public static YyrhSdkManager defaultManager(Context context) {
        if (manager == null) {
            synchronized (YyrhSdkManager.class) {
                if (manager == null) {
                    manager = new YyrhSdkManager(context);
                }
            }
        }

        return manager;
    }
    public void queryOrder(final String order, final HashMap<String, Object> payMap){

        String status = Utils.getParamCnfValuebyKey(context, "YyrhAdParam.cnf",
                "QUERY_ORDER");
        if (status.equals("YES")){
            new Handler().postDelayed(new Runnable() {

                @Override
                public void run() {
                    NetRequestApi.queryOrder(order,payMap);
                }
            }, 5000);
        }



    }


    public void yyrhShowPolicy(final Activity activity, final UserPolicyCallback userPolicyCallback){

        YYLog.i("yyrhShowPolicy ");

        final SharedPreferences sp = activity.getSharedPreferences("yyrh", Activity.MODE_PRIVATE);
        String  isShowPolicy = sp.getString("yyrhShowPolicy", "");

        if (isShowPolicy.equals("")){

            NetRequestApi.initAgreement(activity,new ShowPolicyCallback() {

                @Override
                public void onShow(String agreement_url) {
                    YYLog.i("need to display the policy");
                    new PrivacyPolicyDialog(activity, ResourceUtil.getStyleId(activity, "qj_base_dialog"), agreement_url,
                            new PrivacyPolicyDialog.OnClosePageListener() {
                                @Override
                                public void onUserAgreePolicy() {

                                    YYLog.i("User agree policy");
                                    SharedPreferences.Editor editor = sp.edit();
                                    editor.putString("yyrhShowPolicy", "1");
                                    editor.commit();


                                    userPolicyCallback.onAgree();
                                }

                                @Override
                                public void onUserDisagreePolicy() {
                                    YYLog.i("User disagree policy");
                                    userPolicyCallback.onDisagree();
                                }
                            }).show();


                }

                @Override
                public void onHide() {
                    YYLog.i(" don't need to display the policy");
                    userPolicyCallback.onHide();
                }

                @Override
                public void onError() {
                    YYLog.i(" request policy error");
                    userPolicyCallback.onError();
                }
            });



        }else {
            YYLog.i("The user has agreed to the policy");
            userPolicyCallback.onAgree();
        }


    }
    public void yyrhInitDevice(final Activity activity, boolean isDebug){

        SDKSettings.isDebug = isDebug;

        String isdebug	=	Utils.GetApplicationMetaData(context, "yyrh_debug");
        if (isdebug.equals("true")){
            SDKSettings.isDebug = true;
        }
        SDKSettings.initSetting(activity);

        if (Build.VERSION.SDK_INT > 28) {
            ChannelSDK.getInstance().SDKGetOaid();
        }else{
            SDKSettings.imei =  ImeiUtil.getImei(context);
            SDKEntry.getSdkInstance().tCallBack.onGetOaidCallback(true,SDKSettings.imei);
        }


    }


    public void yyrhInit(final Activity activity){



        NetRequestApi.init(activity, new InitCallback() {
            @Override
            public void onInitSuccess(String msg) {
                SdkManager.defaultManager(activity).onInitSuccess(activity);
                ChannelSDK.getInstance().SDKInitSuccess(msg);
                SDKEntry.getSdkInstance().initCall.onInitSuccess(msg);

            }

            @Override
            public void onInitFailed(String msg) {

                ChannelSDK.getInstance().SDKInitFail(msg);
                SDKEntry.getSdkInstance().initCall.onInitFailed(msg);

                SingleButtonDialog.Builder builder = new SingleButtonDialog.Builder(activity);
                builder.setPositiveButton(new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {

                        System.exit(0);
                    }
                });
                builder.Create(msg).show();
            }

            @Override
            public void onInitError(String _strError) {

                ChannelSDK.getInstance().SDKInitFail(_strError);
                SDKEntry.getSdkInstance().initCall.onInitError(_strError);

                SingleButtonDialog.Builder builder = new SingleButtonDialog.Builder(activity);
                builder.setPositiveButton(new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {

                        System.exit(0);

                    }
                });
                builder.Create(_strError).show();
            }

            @Override
            public void onGetOaid(boolean isSuccess, String oaid) {

            }

            @Override
            public void onShowGameExit() {

            }

        });

        SDKSettings.isSimulator = InspectSimulator.isSimulator(activity);
        Log.i("idSimu:",SDKSettings.isSimulator);
    }
    public void yyrhLogin(Activity activity){
        SharedPreferences sp = activity.getSharedPreferences("yyrh", Activity.MODE_PRIVATE);
        if (!Utils.judgeStrNull(sp.getString("username", "")) &&
                !SDKSettings.LOGINTAG.equals(LOGOUT)) {
            yyrhAutoLogin(activity);

        }
        else {
            yyrh_showLoginDialog(activity);
        }
    }

    private void yyrh_showLoginDialog(Activity activity) {
        destroyFloat();
        Intent intent = new Intent(activity, UseLoginActivity.class);
        intent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP);
        intent.putExtra("isLandscape", Utils.isLandscape(activity));
        intent.putExtra("fragmentTag", FragmentUtils.SDK_LOGIN_TAG);
        activity.startActivity(intent);
    }

    private void yyrhAutoLogin(final Activity activity) {
        AutoLoginDialog.Builder builder = new AutoLoginDialog.Builder(activity);
        builder.setPositiveButton(new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                //取消回调
                dialog.dismiss();

                yyrh_showLoginDialog(activity);

            }
        }).setCloseDialogCallback(new AutoLoginDialog.CloseDialogCallback(){

            @Override
            public void onclose() {
                //成功回调
//                constantDialog.dismiss();
            }
        });

        builder.Create().show();
    }
    public void yyrhLogout(){
        SDKSettings.CHANNELUID = "";
        SDKSettings.UNAME = "";
        SDKSettings.USER_BIRTHDAY = "";
        Activity activity  = (Activity)context;
        activity.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                destroyFloat();
            }

        });

        SDKSettings.LOGINTAG = LOGOUT;
        SDKEntry.getSdkInstance().logoutCall.onLogoutSuccess();

    }
    public void yyrhOpenFloatView(final Activity activity){
        if (isOpenFloatView != true){
            return;
        }
        itemList.clear();

        final int[] menuIcons = new int[]{ResourceUtil.getMipmapId(activity,"qj_user_center_icon"),ResourceUtil.getMipmapId(activity,"qj_switch_account_icon"), ResourceUtil.getMipmapId(activity,"qj_hide_icon")};



        itemList.add(new FloatItem(MENU_ITEMS[0], 0x99000000, 0x99000000, BitmapFactory.decodeResource(activity.getResources(), menuIcons[0]), String.valueOf(0)));
        itemList.add(new FloatItem(MENU_ITEMS[1], 0x99000000, 0x99000000, BitmapFactory.decodeResource(activity.getResources(), menuIcons[1]), String.valueOf(0)));
        itemList.add(new FloatItem(MENU_ITEMS[2], 0x99000000, 0x99000000, BitmapFactory.decodeResource(activity.getResources(), menuIcons[2]), String.valueOf(0)));

        if (mFloatMenu == null) {
            mFloatMenu = new FloatLogoMenu.Builder()
                    .withActivity(activity)
//                    .withContext(mActivity.getApplication())//这个在7.0（包括7.0）以上以及大部分7.0以下的国产手机上需要用户授权，需要搭配<uses-permission android:name="android.permission.SYSTEM_ALERT_WINDOW"/>
                    .logo(BitmapFactory.decodeResource(activity.getResources(),ResourceUtil.getMipmapId(activity,"qj_float_icon")))
                    .drawCicleMenuBg(true)
                    .backMenuColor(0xffe4e3e1)
                    .setBgDrawable(activity.getResources().getDrawable(ResourceUtil.getDrawableId(activity,"qj_game_float_menu_bg")))
                    //这个背景色需要和logo的背景色一致
                    .setFloatItems(itemList)
                    .defaultLocation(FloatLogoMenu.LEFT)
                    .drawRedPointNum(false)
                    .showWithListener(new FloatMenuView.OnMenuClickListener() {
                        @Override
                        public void onItemClick(int position, String title) {

                            itemList.set(position,new FloatItem(MENU_ITEMS[position], 0x99000000, 0x99000000, BitmapFactory.decodeResource(activity.getResources(), menuIcons[position]), String.valueOf(0)));

                            if (title.equals(CLOSE)){
                                destroyFloat();
                                itemList.clear();

                            }else if (title.equals(FEEDBACK)){
                                yyrhLogout();
                            }else if (title.equals(HOME)){
                                HashMap<String,String> map = new HashMap<>();
                                map.put("game_code",SDKSettings.game_code);
                                map.put("gcp_code",SDKSettings.gcp_code);
                                map.put("uname",SDKSettings.UNAME);
                                String url  = Utils.getUserCententerUrl(URLConstants.USERCENTERLISTWEB,map);

                                new WvPageListDialog(activity,ResourceUtil.getStyleId(activity,"qj_base_dialog"),url).show();
                                mFloatMenu.hideMenu();
                            }
                            else{
                                mFloatMenu.hide();
                                mFloatMenu.show();

                            }


                        }

                        @Override
                        public void dismiss() {

                        }
                    });




        }
    }


    public void yyrhPay(Activity activity,HashMap<String, Object> map){


        String url = (String) map.get("url");
        if (Utils.judgeStrNull(url)){
            return;
        }
        new WvPayYyrhDialog(activity,ResourceUtil.getStyleId(activity,"qj_base_dialog"),url,map).show();



    }

    public void yyrhExitGame(final Activity activity){
        CustomExitGameDialog.Builder builder = new CustomExitGameDialog.Builder(activity);
        builder.setPositiveButton(new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
                SDKEntry.getSdkInstance().adSdkCallback.onExitGame(activity);
                SDKEntry.getSdkInstance().exitCall.onExit(true);
            }
        });
        builder.setnegativeButton(new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
            }
        });

        builder.Create().show();
    }
    public void uploadRoleInfo(String type, Activity activity,
                               String roleId, String roleName, String roleLevel, String serverId,
                               String serverName, String hasGold, String vipLevel,String role_power,String partyId,String partyName, String createTime,String charge){
        NetRequestApi.upLoadingRoleInfo(type, activity, roleId,roleName,roleLevel,serverId,
                serverName, hasGold, vipLevel,role_power, partyId, partyName, createTime,charge);

    }

    public void saveUserLoginInfo(final Context context, final String account, String pwd, final String token){
        SharedPreferences sp = context
                .getSharedPreferences("yyrh",
                        Activity.MODE_PRIVATE);
        SharedPreferences.Editor editor = sp.edit();
        editor.putString("username", account);
        editor.putString("password", pwd);
        editor.commit();


        String timeStamp = System.currentTimeMillis() + "";

        String delete_sql = "delete from user where name = '" + account + "'";

        String insert_sql = "insert into user(name,pwd,time) values('" + account
                + "','" + pwd + "','" + timeStamp + "')";

        DatabaseHelper.excuteSql(context, delete_sql);
        DatabaseHelper.excuteSql(context, insert_sql);


        if (isOpenRealName){

            if (!isVefityRealName){
                HashMap<String,String> ifmap = new HashMap<>();
                ifmap.put("game_code",SDKSettings.game_code);
                ifmap.put("gcp_code",SDKSettings.gcp_code);
                ifmap.put("uname",account);
                String url  = Utils.getUserCententerUrl(URLConstants.USERBINDINFO,ifmap);
                if (SDKSettings.isForceRealName){
                    url = url + "&smrz=1";
                    new WvPageListDialog(context, ResourceUtil.getStyleId(context, "qj_base_dialog"), url,
                            new WvPageListDialog.OnClosePageListener() {
                                @Override
                                public void onClose() {
                                    if (SDKSettings.USER_BIRTHDAY.equals("")){
                                        SDKSettings.CHANNELUID = "";
                                        SDKSettings.UNAME = "";

                                    }

                                }

                                @Override
                                public void onRealNameSuccess(String birthday) {
                                    openFloatViewInUIThread((Activity) context);
                                    SDKEntry.getSdkInstance().loginCall.onLoginSuccess(token);
                                    SDKEntry.getSdkInstance().adSdkCallback.onLoginSuccess(account);


                                }
                            },SDKSettings.isForceRealName).show();
                }else {
                    new WvPageListDialog(context, ResourceUtil.getStyleId(context, "qj_base_dialog"), url,
                                 new WvPageListDialog.OnClosePageListener() {
                                     @Override
                                     public void onClose() {
                                         openFloatViewInUIThread((Activity) context);
                                         SDKEntry.getSdkInstance().loginCall.onLoginSuccess(token);
                                         SDKEntry.getSdkInstance().adSdkCallback.onLoginSuccess(account);

                                     }

                                     @Override
                                     public void onRealNameSuccess(String birthday) {
                                         YYLog.i("onRealNameSuccess");
                                     }
                                 }).show();


                }

            }else {
                openFloatViewInUIThread((Activity) context);
                SDKEntry.getSdkInstance().loginCall.onLoginSuccess(token);
                SDKEntry.getSdkInstance().adSdkCallback.onLoginSuccess(account);
            }

        }else{
            openFloatViewInUIThread((Activity) context);
            SDKEntry.getSdkInstance().loginCall.onLoginSuccess(token);
        }
}

    public void yyrhGetRealNameInfo(Activity activity,RealNameMsgCallback msgCallback){

        if(Utils.getTextIsNull(SDKSettings.USER_BIRTHDAY)){
            msgCallback.onLoadRealNameMsg(false,"");
        }else{
            msgCallback.onLoadRealNameMsg(true,SDKSettings.USER_BIRTHDAY);
        }

    }
    private void openFloatViewInUIThread(final Activity gameAct){
        gameAct.runOnUiThread(new Runnable() {
            @Override
            public void run() {

                YyrhSdkManager.defaultManager(gameAct).yyrhOpenFloatView(gameAct);
            }
        });
    }

    public void onResume(Activity activity){

        if (mFloatMenu != null) {

            mFloatMenu.show();
        }

    }
    public void onPause(Activity activity){

        hideFloat();
    }
    public void onDestroy(Activity activity){
        destroyFloat();

    }

    public void hideFloat() {
        if (mFloatMenu != null) {
            mFloatMenu.hide();
        }
    }

    public void destroyFloat() {
        if (mFloatMenu != null) {
            mFloatMenu.destoryFloat();
        }
        itemList.clear();
        mFloatMenu = null;

    }
}
