package com.yyrh.ui.floatmenu;

import android.app.Activity;
import android.content.Context;

import android.content.Intent;
import android.content.SharedPreferences;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.webkit.DownloadListener;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;

import android.widget.ImageView;
import android.widget.LinearLayout;


import com.yyrh.constant.SDKSettings;
import com.yyrh.ui.PageJsInteraction;
import com.yyrh.ui.BaseDialog;
import com.yyrh.ui.userlist.DatabaseHelper;

import com.yyrh.utils.ResourceUtil;
import com.yyrh.utils.TosUtil;


import static com.yyrh.constant.SDKSettings.USER_BIRTHDAY;
import static com.yyrh.constant.SDKSettings.isLandscape;
import static com.yyrh.constant.SDKSettings.isVefityRealName;

public class WvPageListDialog extends BaseDialog {


    private ImageView close_btn,yyrh_loading;
    private Context context;
    private WebView webView;
    private WebSettings webSettings;

    private String url;
    public OnClosePageListener listener;
    private boolean isHiddenClo = false;
    public WvPageListDialog(Context context) {
        super(context);
        this.context = context;
    }


    public WvPageListDialog(Context context, int theme,String url) {
        super(context, theme);
        this.context = context;

        this.url = url;

    }

    public WvPageListDialog(Context context, int theme,String url,OnClosePageListener listener) {
        super(context, theme);
        this.context = context;

        this.url = url;
        this.listener = listener;
    }
    public WvPageListDialog(Context context, int theme,String url,OnClosePageListener listener,boolean isHiddenClose) {
        super(context, theme);
        this.context = context;

        this.url = url;
        this.listener = listener;
        this.isHiddenClo = isHiddenClose;
    }
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

            setContentView(ResourceUtil.getLayoutId(context,
                    "qj_webview_common_dialog"));




        if (!isLandscape){

            LinearLayout ll_webview_common = findViewById(ResourceUtil.getId(context, "ll_webview_common"));
            Float x = Float.valueOf("0.9").floatValue();
            Float y = Float.valueOf("0.9").floatValue();
            ll_webview_common.setScaleX(x);
            ll_webview_common.setScaleY(y);

        }

        webView = findViewById(ResourceUtil.getId(context,
                "wb_user_info"));

        close_btn = findViewById(ResourceUtil.getId(context,
                "close_btn"));

        yyrh_loading = findViewById(ResourceUtil.getId(context, "qj_loading"));
        Animation rotateAnimation = AnimationUtils.loadAnimation(context, ResourceUtil.getAnimId(context, "yyrh_rotate_anim"));
        yyrh_loading.startAnimation(rotateAnimation);

        close_btn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                if (listener != null){
                    listener.onClose();
                }

                webView.destroy();
                dismiss();

            }
        });
        if (isHiddenClo){
            close_btn.setVisibility(View.GONE);
        }

//        reback_btn.setOnClickListener(new View.OnClickListener() {
//            @Override
//            public void onClick(View v) {
//                if (webView.canGoBack()) {
//                    webView.goBack();
//                }else {
//                    webView.destroy();
//                    dismiss();
//                }
//
//            }
//        });


//        wv_title.setText(title);
        webSettings = webView.getSettings();
        webSettings.setAllowFileAccess(true);
        webSettings.setJavaScriptEnabled(true);
        webSettings.setCacheMode(WebSettings.LOAD_NO_CACHE);
        webSettings.setBuiltInZoomControls(false);// 设置支持缩放
        webSettings.setDomStorageEnabled(true);
        webView.setHorizontalScrollBarEnabled(false);//水平不显示
        webView.setVerticalScrollBarEnabled(false); //垂直不显示

        webView.addJavascriptInterface(new PageJsInteraction(this), "yyrhsdk");
        webView.setWebViewClient(new WebViewClient(){
            @Override
            public void onPageFinished(WebView view, String url) {
                super.onPageFinished(view, url);
                yyrh_loading.clearAnimation();
                yyrh_loading.setVisibility(View.GONE);
                if (webView.canGoBack()){
//                    reback_btn.setVisibility(VISIBLE);
                }else{
//                    reback_btn.setVisibility(GONE);
                }
            }

        });

        webView.setDownloadListener(new DownloadListener() {
            @Override
            public void onDownloadStart(String url, String userAgent, String contentDisposition, String mimetype, long contentLength) {
                Uri uri = Uri.parse(url);
                Intent intent = new Intent(Intent.ACTION_VIEW, uri);
                context.startActivity(intent);
            }
        });


        webView.loadUrl(url);
    }




    public interface OnClosePageListener {
         void onClose();
         void onRealNameSuccess(String birthday);
    }



    @Override
    public void zfColse() {
        super.zfColse();
        if (listener != null){
            listener.onClose();
        }
        dismiss();
    }

    @Override
    public void showJsMsg(String message) {
        super.showJsMsg(message);
        new TosUtil(context,TosUtil.TOAST_ERROR,  message).show();
    }

    @Override
    public void usrRn(String message) {
        super.usrRn(message);
        isVefityRealName = true;
        USER_BIRTHDAY = message;
        listener.onRealNameSuccess(message);
    }

    @Override
    public void modifyPwd(String message) {
        super.modifyPwd(message);
        SharedPreferences sp = context
                .getSharedPreferences("yyrh",
                        Activity.MODE_PRIVATE);
        SharedPreferences.Editor editor = sp.edit();
        editor.putString("username", SDKSettings.UNAME);
        editor.putString("password", message);
        editor.commit();

        String timeStamp = System.currentTimeMillis() + "";

        String delete_sql = "delete from user where name = '" + SDKSettings.UNAME + "'";

        String insert_sql = "insert into user(name,pwd,time) values('" + SDKSettings.UNAME
                + "','" + message + "','" + timeStamp + "')";

        DatabaseHelper.excuteSql(context, delete_sql);
        DatabaseHelper.excuteSql(context, insert_sql);
    }

    @Override
    public void dismiss() {
        super.dismiss();
        if (isHiddenClo){
            if (SDKSettings.USER_BIRTHDAY.equals("")){
                SDKSettings.CHANNELUID = "";
                SDKSettings.UNAME = "";

            }

        }
    }
}
